#!/usr/bin/env bash

[[ ${BURR_MENU_LOADED:-} -eq 1 ]] && return

#scripts_brewpixel_roastery_dir=$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )

add_menu() {
declare -A assoc
while IFS=, read -r -a array
do
    ((${#array[@]} >= 1)) || continue
    assoc["${array[@]:0:1}"]="${array[@]:1}"
done < "${scripts_brewpixel_roastery_dir}/../Burr/menu.txt"
declare -a options
for key in "${!assoc[@]}"
do
	options+=("${key}")
    #echo "${key} ---> ${assoc[${key}]}"
done


PS3='Please enter your choice: '
    echo "+------------------------------+"
    echo "| MENU                         |"
    echo "+------------------------------+"
qsort "${options[@]}"
declare -a opt

#opt=(${qsort_ret})
opt=("${qsort_ret[@]#* *}")
   arrsize=${#qsort_ret[@]}
  select option in "${opt[@]}";
  do
    if [ "$REPLY" -eq "${arrsize}" ] || [ "$REPLY" -eq 0 ];
    	then
      		echo "Exiting..."
      		break;
    elif [ 1 -le "$REPLY" ] && [ "$REPLY" -le $((arrsize-1)) ];
    	then
      		echo "You selected $option which is option $REPLY"
      		if [ $REPLY -lt 10 ];
      			then
      				REPLY="0${REPLY}"
      		fi

      		REPLY+=") "
      		run="${REPLY}""${option}"
      		"${assoc[${run}]//[$'\t\r\n ']}"
      		break;
    else
    	echo "Incorrect Input: Select a number 1-${arrsize}"
    fi
  done
}




# display the menu
menu() {

    test "${firstrun}" != false && clear
    echo "+------------------------------+"
    echo "| MENU                         |"
    echo "+------------------------------+"
    echo ""
    echo " 1. New DEFAULT Install"
    echo " 2. New FEATURE Issue Install"
    echo " 3. New HOTFIX Issue Install"
    echo " 4. New MASTER Install"
    echo " 5. New DEVELOP Install"
    echo " 6. New Advanced Install with New Database"
    echo " 7. Show List of Databases"
    echo " 8. New Database"
    echo " 9. Delete Database"
    echo "10. New Payment Gateway (Coming Soon)"
    echo "11. Upload Files (Coming Soon)"
    echo "12. Database Replace Emails (Test Data) (Coming Soon)"
    echo "13. Database Magic Mode (Coming Soon)"
    echo " 0. Exit"
}

# get the user selection for the menu
menuChoice(){
    local choice
    read -p "Enter choice (Use 0 to exit): " choice
    case ${choice} in
        1) installCoreCommerce ;;
        2) installFeature ;;
        3) installHotfix ;;
        4) installMaster ;;
        5) installDevelopment ;;
        6) installAdvanced ;;
        7) showDatabases ;;
        8) addDatabase ;;
        9) dropDatabase ;;
        10) comingSoon ;;
        11) comingSoon ;;
        12) comingSoon ;;
        13) comingSoon ;;
        0) exit 0;;
        *) echo -e "Error..." && sleep 2
    esac
}

startAgain(){
    printf "$(tput setaf 2)Finished.\n\n"
    unset branch
    unset branchDirectory
    unset issue

    read -n1 -p "$(tput setaf 3)Continue? [y,n]$(tput sgr0)" answer

            case ${answer} in
                y|Y) firstrun=false; printf '\n'; continue ;;
                n|N) cd ../${branch}; printf '\n'; exit 0 ;;
                *) echo -e "Error..." && sleep 2

            esac
}

# ----------------------------------------------
# Step #3: Trap CTRL+C, CTRL+Z and quit singles
# ----------------------------------------------
#trap '' SIGINT SIGQUIT SIGTSTP

# -----------------------------------
# Step #4: Main logic - infinite loop
# ------------------------------------
#while true
#do
#    ensure_vagrant_is_running
#    menu
#    menuChoice
#    startAgain
#done
#

BURR_MENU_LOADED=1
